import png
import numpy
from array import array

def matrix_save_png(P, where):
    R = len(P)
    C = len(P[0])
    D = []
    for p in P:
        D.append([int(i) for i in p])
    with open(where, 'wb') as F:
        W = png.Writer(C, R, greyscale=True)
        W.write(F, D)
    return

def read_png_to_matrix(where):
    bitmap = png.Reader(where).read()
    FATALMSG = ""
    if bitmap[0] > 400: FATALMSG += "FATAL: Width > 400.\n"
    if bitmap[1] > 400: FATALMSG += "FATAL: Height > 400.\n"
    if bitmap[3]['bitdepth'] != 8: FATALMSG += "FATAL: bitdepth != 8\n"
    if bitmap[3]['planes'] != 1: FATALMSG += "FATAL: planes != 1\n"
    if bitmap[3]['greyscale'] != True: FATALMSG += "FATAL: greyscale == False\n"
    if bitmap[3]['alpha'] != False: FATALMSG += "FATAL: alpha == True\n"
    if FATALMSG != "": exit(FATALMSG + "-- aborted due to above issues.")

    grey_matrix = []
    
    for grey_row in bitmap[2]:
        grey_matrix.append(grey_row)
    
    grey_matrix = numpy.array(grey_matrix)
    
    return grey_matrix
